import datetime
import ftplib
from pathkit.base import BasePath as BasePath, Local as Local, retry as retry
from pathkit.config import EnvConfig as EnvConfig
from typing import Any, Generator, Optional

def interrupt(*_, **__) -> None: ...

class FTPPath(BasePath):
    _section = ("ftp",)
    _creator = ftplib.FTP
    client: ftplib.FTP
    def _reset(self, section: str) -> Optional[Exception]: ...
    @property
    def exists(self) -> bool: ...
    def is_dir(self) -> bool: ...
    def read(self) -> bytes: ...
    def write(self, data: bytes) -> None: ...
    def upload(self, local_path: str) -> None: ...
    def delete(self) -> None: ...
    def mkdir(self) -> None: ...
    def glob(self, pattern: str = '*') -> Generator['FTPPath', Any, Any]: ...
    @property
    def mtime(self) -> datetime.datetime: ...
